/******************************************************************/
/*   si x es un vector de complejos ( tcomplejo[] )				  */
/*   y gamma es tal que dos elevado a gamma es el nmero		  */
/*   de elementos del vector.									  */
/*   entonces una llamada fft(x,gamma) devuelve sobre x[] la	  */
/*   y[] = fft de x[] definida como								  */
/*    		y[m] =												  */
/* 			 SUM desde k=0 hasta k= N-1 de						  */
/*			x[k]*exp(j 2 PI k m / N ) ;							  */
/*			m = 0,1, ... , N-1									  */
/*   donde N =  2 elevado a gamma 								  */
/******************************************************************/
/* compilar con libcx.a , -lm */
#include <math.h>
#include "deftipo.h"
/*----------------funcin fft------------------------*/
int n,nu;
/*--------funcin w elevado a p-------------------*/
static tcomplejo wel(p)
int p;
{
	tcomplejo w;			/* w=exp(-j2PI/n) */
	w.re=cos(2.0*M_PI*(double)p/(double)n);
	w.im=sin(-2.0*M_PI*(double)p/(double)n);
	return(w);
}
/* fin de w elevado a p */
/*-----------funcin de inversin de bits------------*/
/* bloque 18 */
static ibr(m)
int m;
{
	int j2,i1,aux;
	for ( i1 = 1,aux= 0; i1 <= nu ; i1++ )
	{
		j2=m/2;
		aux=2*aux+m-2*j2;
		m=j2;
	}
	return (aux);
}
/* fin de inversin de bits */
/*---------------funcin de reordenacin-------------*/
static orden(vz)
tcomplejo vz[];
{
	tcomplejo t3;
	int i,k=0;
	do{				/* desde k=0 hasta n-1 */
		i=ibr(k);
		if ( i > k ) {
			t3=vz[k];
			vz[k]=vz[i];
			vz[i]=t3;
		}
	} while ( ++k < n );
	return(0);
}
/* fin de funcin de reordenacin */
/* bloque 1 */
fft(vz,gamma)
tcomplejo vz[];		/*vector de complejos a transformar*/
int gamma;			/*dimensin 2 elevado a gamma*/
{
	/* bloque 2 */
	int n2;				/*espaciado*/
	int nu1;			/*desplazamiento*/
	int l;				/*nm. columna*/
	int i;				/*salto*/
	tcomplejo t1;		/*auxiliar*/
	int k=0;			/* elemento de la columna */
	/*----fft propiamente dicha----*/
	n=(int)pow(2.0,(double)gamma);	/*n=2 elevado a gamma*/
	nu=gamma;
	n2=n/2;
	nu1=gamma-1;
	/* bloque 3 */
	for ( l=1; l <= gamma ; l++ )	/*hacer gamma columnas*/
	{
		/* no */
		/* bloque 4 */
		do
		{
			for ( i=1 ; i <= n2 ; i++ )		/*control de salto*/
			{
				/* bloque 5,6 */
				t1=prdc(wel(ibr(k/(int)pow(2.0,(double)nu1))),vz[k+n2]);
				vz[k+n2]=resc(vz[k],t1);
				vz[k]=sumc(vz[k],t1);
				/* bloque 7 */
				++k;
				/* bloque 8 */
			}
			/* bloque 10 */
			k=k+n2;
		}	/* bloque 11 */		while ( k < n-1 );
		/* bloque 12 */
		k=0;
		--nu1;
		n2=n2/2;
	}
	/* yes */
	orden(vz);
	return(0);
}
