/* compilar con libcx.a -lm */
/*
aproximacin a los coeficientes del desarrollo de Fourier
de la funcin y(t) muestreada desde k=0 hasta m-1 ( m mltiplo de 4 )
definidos como:

	y(t)= a[0]/2+SUM [ a[k] cos ( 2PIf*t ) + b[k] sen ( 2PIf*t ) ]

	siendo SUM: suma desde k=1 hasta m/2-1

Nota: se utiliza la fft de m puntos calculando la de m/2
*/
#include <math.h>
#include "deftipo.h"
main()
{
	tcomplejo x[20000];
	double y[20000],c[20000],a[20000],b[20000];
	int gamma,n,m,k;
	double to = 2.0*M_PI;	/* periodo de y(t) */
	double t;				/* periodo de muestreo */
/* entrada de artistas */
puts("Serie de Fourier de onda cuadrada de un tercio de periodo\n");
printf("gamma ( 2 elevado a gamma-1 coeficientes )? ");
scanf("%d",&gamma);
	m=(int)pow(2.0,(double)gamma);
	n=m/2;
	t=to/m;
	gamma--;
/* definicin y muestreo de y(t) */
	for(k=0;k<m; k++){
		double time;
		time=(double)k*t;
		if ((M_PI/3.0 < time ) && (time < 5.0/3.0*M_PI)) y[k]=0.0;
		else y[k]=1.0;
	}
/* fin de la definicin */
	for (k=0;k<n;k++){
		x[k].re=y[2*k];
		x[k].im=y[2*k+1];
	}
	fft(x,gamma);
	x[n]=x[0];
	for(k=0;k<n;k++){
		tcomplejo z1,z2,z3;
		z1.re=1.0-sin(M_PI*(double)k/(double)n);
		z1.im=-cos(M_PI*(double)k/(double)n);
		z2.re=2.0-z1.re;
		z2.im=-z1.im;
		z3=cnjc(sumc(prdc(z1,x[k]),prdc(z2,cnjc(x[n-k]))));
		a[k]=z3.re/(double)m;
		b[k]=z3.im/(double)m;
/* Valores tericos */
		if (k==0) c[0]=2.0/3.0;
		else c[k]=2.0/M_PI/(double)k*sin((double)k*M_PI/3.0);
	}
/* salida de emergencia */
	printf("trminos cos, trminos sin    tericos cos,sin\n");
	for (k=0;k<n;k++){
	printf("%4d) %10.5lf,%10.5lf # %10.5lf,%10.5lf\n",k,a[k],b[k],c[k],0.0);
	}
}
